## strawberry 1.2.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

project(strawberry C CXX)

if(APPLE)
  enable_language(OBJC OBJCXX)
endif()

if(POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW)
endif()
if(POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW)
endif()

include(CheckCXXCompilerFlag)
include(CheckCXXSourceRuns)
include(CheckIncludeFiles)
include(FindPkgConfig)
include(cmake/Version.cmake)
include(cmake/Summary.cmake)
include(cmake/OptionalSource.cmake)
include(cmake/ParseArguments.cmake)

if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
  set(LINUX ON)
endif()
if(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
  set(FREEBSD ON)
endif()
if(CMAKE_SYSTEM_NAME STREQUAL "OpenBSD")
  set(OPENBSD ON)
endif()

if(LINUX)
  include(cmake/Rpm.cmake)
  include(cmake/Deb.cmake)
endif()
if(APPLE)
  include(cmake/Dmg.cmake)
endif()

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

if(CMAKE_BUILD_TYPE MATCHES "Release")
  add_definitions(-DNDEBUG)
  set(ENABLE_DEBUG_OUTPUT_DEFAULT OFF)
else()
  set(ENABLE_DEBUG_OUTPUT_DEFAULT ON)
endif()

if(APPLE OR WIN32)
  set(USE_BUNDLE_DEFAULT ON)
else()
  set(USE_BUNDLE_DEFAULT OFF)
endif()

if(WIN32)
  if(CMAKE_BUILD_TYPE MATCHES "Release")
    set(ENABLE_WIN32_CONSOLE_DEFAULT OFF)
  else()
    set(ENABLE_WIN32_CONSOLE_DEFAULT ON)
  endif()
endif()

option(BUILD_WERROR "Build with -Werror" OFF)
option(USE_RPATH "Use RPATH" APPLE)
option(USE_INSTALL_PREFIX "Look for data in CMAKE_INSTALL_PREFIX" ON)
option(INSTALL_TRANSLATIONS "Install translations" OFF)
option(ENABLE_DEBUG_OUTPUT "Enable debug output" ${ENABLE_DEBUG_OUTPUT_DEFAULT})
option(USE_BUNDLE "Bundle dependencies" ${USE_BUNDLE_DEFAULT})

if(WIN32)
  option(ENABLE_WIN32_CONSOLE "Show the windows console even outside Debug mode" ${ENABLE_WIN32_CONSOLE_DEFAULT})
  option(USE_QTSPARKLE "Use Qt Sparkle updater" ON)
endif()

if(MSVC)
  set(CMAKE_C_STANDARD 99)
else()
  set(CMAKE_C_STANDARD 11)
endif()

set(CMAKE_C_STANDARD_REQUIRED ON)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if(MSVC)
  list(APPEND COMPILE_OPTIONS /MP)
else()
  list(APPEND COMPILE_OPTIONS
    $<$<COMPILE_LANGUAGE:C>:-std=c11>
    $<$<COMPILE_LANGUAGE:CXX>:-std=c++17>
    -Wall
    -Wextra
    -Wpedantic
    -Wunused
    -Wshadow
    -Wundef
    -Wuninitialized
    -Wredundant-decls
    -Wcast-align
    -Winit-self
    -Wmissing-include-dirs
    -Wmissing-declarations
    -Wstrict-overflow=2
    -Wunused-parameter
    -Wformat=2
    -Wdisabled-optimization
    $<$<COMPILE_LANGUAGE:CXX>:-Woverloaded-virtual>
    $<$<COMPILE_LANGUAGE:CXX>:-Wold-style-cast>
  )
  if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    list(APPEND COMPILE_OPTIONS -Wno-unused-command-line-argument)
  endif()
endif()

add_compile_options(${COMPILE_OPTIONS})

add_definitions(
  -DBOOST_BIND_NO_PLACEHOLDERS
  -DQT_STRICT_ITERATORS
  -DQT_NO_CAST_FROM_BYTEARRAY
  -DQT_USE_QSTRINGBUILDER
  -DQT_NO_URL_CAST_FROM_STRING
  -DQT_NO_CAST_TO_ASCII
  -DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT
  -DQT_NO_FOREACH
  -DQT_ASCII_CAST_WARNINGS
  -DQT_NO_CAST_FROM_ASCII
  -DQT_NO_KEYWORDS
  -DQT_NO_SIGNALS_SLOTS_KEYWORDS
)

if(WIN32)
  add_definitions(-DUNICODE)
endif()

if(BUILD_WERROR)
  set(CMAKE_COMPILE_WARNING_AS_ERROR ON)
endif()

if(NOT ENABLE_DEBUG_OUTPUT)
  add_definitions(-DQT_NO_DEBUG_OUTPUT)
endif()

if(USE_RPATH)
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif()

find_program(CCACHE_EXECUTABLE NAMES ccache)
if(CCACHE_EXECUTABLE)
  message(STATUS "ccache found: will be used for compilation and linkage")
  SET_PROPERTY(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE_EXECUTABLE})
  SET_PROPERTY(GLOBAL PROPERTY RULE_LAUNCH_LINK ${CCACHE_EXECUTABLE})
endif()

find_package(PkgConfig REQUIRED)
find_package(Threads REQUIRED)
find_package(Backtrace)
if(Backtrace_FOUND)
  set(HAVE_BACKTRACE ON)
endif()
find_package(Boost CONFIG)
if(NOT Boost_FOUND)
  find_package(Boost REQUIRED)
endif()
find_package(ICU COMPONENTS uc i18n REQUIRED)
if(LINUX)
  find_package(ALSA REQUIRED)
else()
  find_package(ALSA)
endif()
if(UNIX AND NOT APPLE)
  find_package(X11 COMPONENTS X11_xcb)
endif()
pkg_check_modules(GLIB REQUIRED IMPORTED_TARGET glib-2.0)
pkg_check_modules(GOBJECT REQUIRED IMPORTED_TARGET gobject-2.0)
if(UNIX AND NOT APPLE)
  pkg_check_modules(GIO REQUIRED IMPORTED_TARGET gio-2.0)
  if(GIO_FOUND AND UNIX)
    pkg_check_modules(GIO_UNIX IMPORTED_TARGET gio-unix-2.0)
  endif()
endif()
pkg_check_modules(LIBCDIO IMPORTED_TARGET libcdio)
pkg_check_modules(GSTREAMER REQUIRED IMPORTED_TARGET gstreamer-1.0)
pkg_check_modules(GSTREAMER_BASE REQUIRED IMPORTED_TARGET gstreamer-base-1.0)
pkg_check_modules(GSTREAMER_AUDIO REQUIRED IMPORTED_TARGET gstreamer-audio-1.0)
pkg_check_modules(GSTREAMER_APP REQUIRED IMPORTED_TARGET gstreamer-app-1.0)
pkg_check_modules(GSTREAMER_TAG REQUIRED IMPORTED_TARGET gstreamer-tag-1.0)
pkg_check_modules(GSTREAMER_PBUTILS REQUIRED IMPORTED_TARGET gstreamer-pbutils-1.0)
pkg_check_modules(SQLITE REQUIRED IMPORTED_TARGET sqlite3>=3.9)
pkg_check_modules(LIBPULSE IMPORTED_TARGET libpulse)
pkg_check_modules(CHROMAPRINT IMPORTED_TARGET libchromaprint>=1.4)
pkg_check_modules(FFTW3 IMPORTED_TARGET fftw3)
pkg_check_modules(LIBEBUR128 IMPORTED_TARGET libebur128)
pkg_check_modules(LIBGPOD IMPORTED_TARGET libgpod-1.0>=0.7.92)
pkg_check_modules(LIBMTP IMPORTED_TARGET libmtp>=1.0)
pkg_check_modules(GDK_PIXBUF IMPORTED_TARGET gdk-pixbuf-2.0)

find_package(TagLib 2.0)
if(TARGET TagLib::TagLib)
  set(TAGLIB_FOUND ON)
  set(TAGLIB_LIBRARIES TagLib::TagLib)
  set(HAVE_TAGLIB_DSFFILE ON)
  set(HAVE_TAGLIB_DSDIFFFILE ON)
else()
  pkg_check_modules(TAGLIB REQUIRED IMPORTED_TARGET taglib>=1.12)
endif()

find_package(GTest)

set(QT_VERSION_MAJOR 6)
set(QT_MIN_VERSION 6.4.0)
set(QT_DEFAULT_MAJOR_VERSION ${QT_VERSION_MAJOR})
set(QT_COMPONENTS Core Concurrent Gui Widgets Network Sql)
set(QT_OPTIONAL_COMPONENTS LinguistTools Test)
if(UNIX AND NOT APPLE)
  list(APPEND QT_OPTIONAL_COMPONENTS DBus)
endif()

find_package(Qt${QT_VERSION_MAJOR} ${QT_MIN_VERSION} COMPONENTS ${QT_COMPONENTS} REQUIRED OPTIONAL_COMPONENTS ${QT_OPTIONAL_COMPONENTS})

if(Qt${QT_VERSION_MAJOR}DBus_FOUND)
  set(DBUS_FOUND ON)
endif()

if(X11_FOUND)

  find_path(QPA_QPLATFORMNATIVEINTERFACE_H qpa/qplatformnativeinterface.h PATHS ${Qt${QT_VERSION_MAJOR}Gui_INCLUDE_DIRS} ${Qt${QT_VERSION_MAJOR}Gui_PRIVATE_INCLUDE_DIRS})
  if(NOT QPA_QPLATFORMNATIVEINTERFACE_H)
    find_path(QPA_QPLATFORMNATIVEINTERFACE_H ${Qt${QT_VERSION_MAJOR}Gui_VERSION}/QtGui/qpa/qplatformnativeinterface.h PATHS ${Qt${QT_VERSION_MAJOR}Gui_INCLUDE_DIRS} ${Qt${QT_VERSION_MAJOR}Gui_PRIVATE_INCLUDE_DIRS})
  endif()
  if(QPA_QPLATFORMNATIVEINTERFACE_H)
    set(HAVE_QPA_QPLATFORMNATIVEINTERFACE_H ON)
    message(STATUS "Have qpa/qplatformnativeinterface.h header.")
  else()
    message(STATUS "Missing qpa/qplatformnativeinterface.h header.")
  endif()

  # Check for QX11Application (Qt 6 compiled with XCB).
  set(CMAKE_REQUIRED_FLAGS "-std=c++17")
  set(CMAKE_REQUIRED_LIBRARIES Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Gui)
  check_cxx_source_compiles("
    #include <QGuiApplication>
    int main() {
      (void)qApp->nativeInterface<QNativeInterface::QX11Application>();
      return 0;
    }
    "
    HAVE_QX11APPLICATION
  )
  unset(CMAKE_REQUIRED_FLAGS)
  unset(CMAKE_REQUIRED_LIBRARIES)

endif()

# SingleApplication
set(KDSINGLEAPPLICATION_NAME "KDSingleApplication-qt${QT_VERSION_MAJOR}")
find_package(${KDSINGLEAPPLICATION_NAME} 1.1.0)
if(TARGET KDAB::kdsingleapplication)
  set(KDSINGLEAPPLICATION_VERSION "${KDSingleApplication-qt6_VERSION}")
  message(STATUS "Using system KDSingleApplication (Version ${KDSINGLEAPPLICATION_VERSION})")
  set(SINGLEAPPLICATION_LIBRARIES KDAB::kdsingleapplication)
else()
  message(STATUS "Using 3rdparty KDSingleApplication")
  add_subdirectory(3rdparty/kdsingleapplication)
  set(SINGLEAPPLICATION_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/kdsingleapplication/KDSingleApplication/src)
  set(SINGLEAPPLICATION_LIBRARIES kdsingleapplication)
  add_definitions(-DKDSINGLEAPPLICATION_STATIC_BUILD)
endif()

# if(APPLE)
#   find_package(SPMediaKeyTap REQUIRED)
# endif()

if(WIN32)
  find_package(getopt-win REQUIRED)
  if(USE_QTSPARKLE)
    pkg_check_modules(QTSPARKLE REQUIRED IMPORTED_TARGET qtsparkle-qt${QT_VERSION_MAJOR})
    set(HAVE_QTSPARKLE ON)
  endif()
endif()

optional_component(ALSA ON "ALSA integration"
  DEPENDS "alsa" ALSA_FOUND
)

optional_component(PULSE ON "PulseAudio integration"
  DEPENDS "libpulse" LIBPULSE_FOUND
)

optional_component(DBUS ON "D-Bus support"
  DEPENDS "Qt D-Bus" DBUS_FOUND
)

optional_component(MPRIS2 ON "MPRIS2 D-Bus Interface"
  DEPENDS "D-Bus support" HAVE_DBUS
)

optional_component(SONGFINGERPRINTING ON "Song fingerprinting and tracking"
  DEPENDS "chromaprint" CHROMAPRINT_FOUND
)

optional_component(MUSICBRAINZ ON "MusicBrainz integration"
  DEPENDS "chromaprint" CHROMAPRINT_FOUND
)

optional_component(X11_GLOBALSHORTCUTS ON "X11 global shortcuts"
  DEPENDS "X11" X11_FOUND
  DEPENDS "QX11Application" HAVE_QX11APPLICATION
)

optional_component(KGLOBALACCEL_GLOBALSHORTCUTS ON "KGlobalAccel global shortcuts"
  DEPENDS "D-Bus support" HAVE_DBUS
)

optional_component(UDISKS2 ON "Devices: UDisks2 backend"
  DEPENDS "D-Bus support" HAVE_DBUS
)

optional_component(GIO ON "Devices: GIO device backend"
  DEPENDS "libgio" GIO_FOUND
)

optional_component(GIO_UNIX ON "Devices: GIO device backend (Unix support)"
  DEPENDS "libgio-unix" GIO_UNIX_FOUND
)

optional_component(AUDIOCD ON "Devices: Audio CD support"
  DEPENDS "libcdio" LIBCDIO_FOUND
)

optional_component(MTP ON "Devices: MTP support"
  DEPENDS "libmtp" LIBMTP_FOUND
)

optional_component(GPOD ON "Devices: iPod classic support"
  DEPENDS "libgpod" LIBGPOD_FOUND
  DEPENDS "gdk-pixbuf" GDK_PIXBUF_FOUND
)

optional_component(TRANSLATIONS ON "Translations"
  DEPENDS "Qt LinguistTools" Qt${QT_VERSION_MAJOR}LinguistTools_FOUND
)

optional_component(SUBSONIC ON "Streaming: Subsonic")
optional_component(TIDAL ON "Streaming: Tidal")
optional_component(SPOTIFY ON "Streaming: Spotify")
optional_component(QOBUZ ON "Streaming: Qobuz")

optional_component(MOODBAR ON "Moodbar"
  DEPENDS "fftw3" FFTW3_FOUND
)

optional_component(EBUR128 ON "EBU R 128 loudness normalization"
  DEPENDS "libebur128" LIBEBUR128_FOUND
)

if(HAVE_SONGFINGERPRINTING OR HAVE_MUSICBRAINZ)
  set(HAVE_CHROMAPRINT ON)
endif()

if(HAVE_X11_GLOBALSHORTCUTS OR HAVE_KGLOBALACCEL_GLOBALSHORTCUTS OR APPLE OR WIN32)
  set(HAVE_GLOBALSHORTCUTS ON)
endif()

if(NOT CMAKE_CROSSCOMPILING)
  # Check that we have Qt with sqlite driver
  set(CMAKE_REQUIRED_FLAGS "-std=c++17")
  set(CMAKE_REQUIRED_LIBRARIES Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Sql)
  check_cxx_source_runs("
    #include <QCoreApplication>
    #include <QSqlDatabase>
    #include <QSqlQuery>
    int main(int argc, char *argv[]) {
      QCoreApplication app(argc, argv);
      QSqlDatabase db = QSqlDatabase::addDatabase(\"QSQLITE\");
      db.setDatabaseName(\":memory:\");
      if (!db.open()) { return 1; }
      QSqlQuery q(db);
      q.prepare(\"CREATE TABLE test (test TEXT);\");
      if (!q.exec()) return 1;
    }
    "
    QT_SQLITE_TEST
  )
endif()

add_executable(strawberry)

if(APPLE)
  set_target_properties(strawberry PROPERTIES MACOSX_BUNDLE TRUE)
  set_target_properties(strawberry PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/dist/macos/Info.plist")
endif()

if(WIN32 AND NOT ENABLE_WIN32_CONSOLE)
  set_target_properties(strawberry PROPERTIES WIN32_EXECUTABLE TRUE)
endif()

set(SOURCES
  src/core/logging.cpp
  src/core/mainwindow.cpp
  src/core/application.cpp
  src/core/playerinterface.cpp
  src/core/player.cpp
  src/core/commandlineoptions.cpp
  src/core/database.cpp
  src/core/memorydatabase.cpp
  src/core/sqlquery.cpp
  src/core/sqlrow.cpp
  src/core/metatypes.cpp
  src/core/deletefiles.cpp
  src/core/filesystemmusicstorage.cpp
  src/core/filesystemwatcherinterface.cpp
  src/core/mergedproxymodel.cpp
  src/core/multisortfilterproxy.cpp
  src/core/musicstorage.cpp
  src/core/networkaccessmanager.cpp

=== tests/CMakeLists.txt ===
enable_testing()

add_custom_target(strawberry_tests echo "Running Strawberry tests" WORKING_DIRECTORY ${CURRENT_BINARY_DIR})
add_custom_target(build_tests WORKING_DIRECTORY ${CURRENT_BINARY_DIR})
add_dependencies(strawberry_tests build_tests)

add_definitions(-DGTEST_USE_OWN_TR1_TUPLE=1)

set(TESTUTILS-SOURCES
  src/mock_networkaccessmanager.cpp
  src/mock_playlistitem.cpp
  src/test_utils.cpp
  src/testobjectdecorators.cpp
)

set(TESTUTILS-MOC-HEADERS src/mock_networkaccessmanager.h src/test_utils.h src/testobjectdecorators.h)

qt_wrap_cpp(TESTUTILS-SOURCES-MOC ${TESTUTILS-MOC-HEADERS})

add_library(test_utils STATIC EXCLUDE_FROM_ALL ${TESTUTILS-SOURCES} ${TESTUTILS-SOURCES-MOC})
target_include_directories(test_utils PRIVATE
  ${CMAKE_BINARY_DIR}/src
  ${CMAKE_SOURCE_DIR}/src
)
target_link_libraries(test_utils PRIVATE
  GTest::GTest
  GTest::gmock
  Qt${QT_VERSION_MAJOR}::Core
  Qt${QT_VERSION_MAJOR}::Widgets
  Qt${QT_VERSION_MAJOR}::Network
  Qt${QT_VERSION_MAJOR}::Sql
  Qt${QT_VERSION_MAJOR}::Test
)

qt_add_resources(TEST-RESOURCE-SOURCES data/testdata.qrc ${CMAKE_SOURCE_DIR}/data/data.qrc ${CMAKE_SOURCE_DIR}/data/icons.qrc)

add_library(test_main STATIC EXCLUDE_FROM_ALL ${TEST-RESOURCE-SOURCES} src/main.cpp)
target_include_directories(test_main PRIVATE
  ${CMAKE_BINARY_DIR}/src
  ${CMAKE_SOURCE_DIR}/src
)
target_link_libraries(test_main PRIVATE
  ${CMAKE_THREAD_LIBS_INIT}
  PkgConfig::GLIB
  PkgConfig::GOBJECT
  PkgConfig::GSTREAMER_BASE
  Qt${QT_VERSION_MAJOR}::Core
  Qt${QT_VERSION_MAJOR}::Widgets
  strawberry_lib
)

add_library(test_gui_main STATIC EXCLUDE_FROM_ALL ${TEST-RESOURCE-SOURCES} src/main.cpp)
target_include_directories(test_gui_main PRIVATE
  ${CMAKE_BINARY_DIR}/src
  ${CMAKE_SOURCE_DIR}/src
)
target_link_libraries(test_gui_main PRIVATE
  ${CMAKE_THREAD_LIBS_INIT}
  PkgConfig::GLIB
  PkgConfig::GOBJECT
  PkgConfig::GSTREAMER_BASE
  Qt${QT_VERSION_MAJOR}::Core
  Qt${QT_VERSION_MAJOR}::Widgets
  strawberry_lib
)
set_target_properties(test_gui_main PROPERTIES COMPILE_DEFINITIONS GUI)

# Given a file foo_test.cpp, creates a target foo_test and adds it to the test target.
macro(add_test_file test_source gui_required)
    get_filename_component(TEST_NAME ${test_source} NAME_WE)
    add_executable(${TEST_NAME} EXCLUDE_FROM_ALL ${test_source})
    target_include_directories(${TEST_NAME} PRIVATE
      ${CMAKE_BINARY_DIR}/src
      ${CMAKE_SOURCE_DIR}/src
    )
    target_link_libraries(${TEST_NAME} PRIVATE
      ${CMAKE_THREAD_LIBS_INIT}
      PkgConfig::GLIB
      PkgConfig::GOBJECT
      PkgConfig::GSTREAMER_BASE
      Qt${QT_VERSION_MAJOR}::Core
      Qt${QT_VERSION_MAJOR}::Concurrent
      Qt${QT_VERSION_MAJOR}::Network
      Qt${QT_VERSION_MAJOR}::Sql
      Qt${QT_VERSION_MAJOR}::Test
      Qt${QT_VERSION_MAJOR}::Widgets
    )
    target_link_libraries(${TEST_NAME} PRIVATE test_utils)
    set(GUI_REQUIRED ${gui_required})
    if(GUI_REQUIRED)
      target_link_libraries(${TEST_NAME} PRIVATE test_gui_main)
    else()
      target_link_libraries(${TEST_NAME} PRIVATE test_main)
    endif()

    add_test(strawberry_tests ${TEST_NAME})
    add_custom_command(TARGET strawberry_tests POST_BUILD COMMAND ./${TEST_NAME}${CMAKE_EXECUTABLE_SUFFIX})
    add_dependencies(build_tests ${TEST_NAME})
endmacro(add_test_file)

add_test_file(src/utilities_test.cpp false)
add_test_file(src/concurrentrun_test.cpp false)
add_test_file(src/mergedproxymodel_test.cpp false)
add_test_file(src/sqlite_test.cpp false)
add_test_file(src/tagreader_test.cpp false)
add_test_file(src/collectionbackend_test.cpp false)
add_test_file(src/collectionmodel_test.cpp true)
add_test_file(src/songplaylistitem_test.cpp false)
add_test_file(src/organizeformat_test.cpp false)
add_test_file(src/playlist_test.cpp true)

add_custom_target(run_strawberry_tests COMMAND ${CMAKE_CTEST_COMMAND} -V DEPENDS strawberry_tests)

=== debian/changelog ===
strawberry (1.2.3-0.1~mx23+1) mx; urgency=medium

  * New upstream release

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 08 Dec 2024 15:10:46 -0800

strawberry (1.2.2-1) unstable; urgency=medium

  * New upstream release (drops external tagreader)
  * Rework patch, drop unneeded patch
  * Drop libdbus-1-dev, protobuf-devel, protobuf-devel from build--deps.
  * Update d/copyright

 -- Peter Blackman <peter@pblackman.plus.com>  Sat, 30 Nov 2024 11:13:31 +0000

strawberry (1.1.3-1) unstable; urgency=medium

  * New upstream release
  * Refresh patches

 -- Peter Blackman <peter@pblackman.plus.com>  Wed, 25 Sep 2024 11:36:42 +0100

=== debian/control ===
Source: strawberry
Homepage: https://strawberrymusicplayer.org
Section: sound
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Peter Blackman <peter@pblackman.plus.com>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libasound2-dev,
               libboost-dev,
               libcdio-dev,
               libchromaprint-dev,
               libebur128-dev,
               libfftw3-dev,
               libglib2.0-dev,
               libgnutls28-dev,
               libgpod-dev,
               libgstreamer-plugins-base1.0-dev,
               libgstreamer1.0-dev,
               libicu-dev,
               libmtp-dev,
               libpulse-dev,
               libsqlite3-dev,
               libtag1-dev,
               libvlc-dev,
               qt6-base-dev,
               qt6-base-dev-tools,
               qt6-l10n-tools,
               qt6-tools-dev,
               qt6-tools-dev-tools
Standards-Version: 4.7.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/strawberry
Vcs-Git: https://salsa.debian.org/debian/strawberry.git

Package: strawberry
Architecture: any
Depends: gstreamer1.0-plugins-base,
         gstreamer1.0-plugins-good,
         libqt6sql6-sqlite,
         qt6-qpa-plugins,
         sqlite3,
         ${misc:Depends},
         ${shlibs:Depends},
         gstreamer1.0-alsa, gstreamer1.0-pulseaudio,
         gstreamer1.0-plugins-bad, gstreamer1.0-plugins-ugly,
Suggests:  qt6ct
Description: audio player and music collection organizer
 Strawberry is a music player aimed at music collectors and audiophiles.
 It is a fork of Clementine. The name is inspired by the band Strawbs.
 .
 Features:
  - Play and organize music
  - Supports WAV, FLAC, WavPack, Ogg Vorbis, Speex, MPC, TrueAudio,
  -   AIFF, MP4, MP3 and ASF
  - Audio CD playback
  - Native desktop notifications
  - Playlist management
  - Playlists in multiple formats
  - Advanced audio and device configuration for bit-perfect playback on Linux
  - Edit tags on audio files
  - Automatically retrieve tags from MusicBrainz
  - Album cover art from Last.fm, Musicbrainz, Discogs, Musixmatch, Deezer,
  -   Tidal, Qobuz and Spotify
  - Song lyrics from Genius, Musixmatch, ChartLyrics, lyrics.ovh,
     lololyrics.com, songlyrics.com, azlyrics.com and elyrics.net
  - Audio analyzer
  - Audio equalizer
  - Transfer music to mass-storage USB players, MTP compatible devices
  -   and iPod Nano/Classic
  - Scrobbler with support for Last.fm, Libre.fm and ListenBrainz
  - Streaming support for Subsonic-compatible servers
  - Unofficial streaming support for Tidal and Qobuz

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS   = hardening=+all

%:
	dh $@

# Rename script
execute_after_dh_auto_install:
	cp -v dist/scripts/import-from-clementine.sh \
	      debian/strawberry/usr/bin/strawberry-import-from-clementine

# No dbgsym packages:
override_dh_strip:
	@echo "not building dbgsym packages for MX Linux"
	dh_strip --no-automatic-dbgsym

## strawberry 1.2.4

=== debian/changelog ===
strawberry (1.2.4-1) unstable; urgency=medium

  * New upstream release
  * Update d/copyright year
  * Change libtag dependencies (for libtag transition)

 -- Peter Blackman <peter@pblackman.plus.com>  Sat, 11 Jan 2025 15:21:00 +0000

strawberry (1.2.3-1) unstable; urgency=medium

  * New upstream release

 -- Peter Blackman <peter@pblackman.plus.com>  Tue, 10 Dec 2024 10:17:55 +0000

=== debian/control ===
Source: strawberry
Homepage: https://strawberrymusicplayer.org
Section: sound
Priority: optional
Maintainer: Peter Blackman <peter@pblackman.plus.com>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libasound2-dev,
 libboost-dev,
 libcdio-dev,
 libchromaprint-dev,
 libebur128-dev,
 libfftw3-dev,
 libglib2.0-dev,
 libgnutls28-dev,
 libgpod-dev,
 libgstreamer-plugins-base1.0-dev,
 libgstreamer1.0-dev,
 libicu-dev,
 libmtp-dev,
 libpulse-dev,
 libsqlite3-dev,
 libtag-c-dev,
 libvlc-dev,
 qt6-base-dev,
 qt6-base-dev-tools,
 qt6-l10n-tools,
 qt6-tools-dev,
 qt6-tools-dev-tools
Standards-Version: 4.7.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/strawberry
Vcs-Git: https://salsa.debian.org/debian/strawberry.git

Package: strawberry
Architecture: any
Depends:
 gstreamer1.0-plugins-base,
 gstreamer1.0-plugins-good,
 libqt6sql6-sqlite,
 qt6-qpa-plugins,
 sqlite3,
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 gstreamer1.0-alsa,
 gstreamer1.0-pulseaudio
Suggests:
 gstreamer1.0-plugins-bad,
 gstreamer1.0-plugins-ugly,
 qt6ct
Description: audio player and music collection organizer
 Strawberry is a music player aimed at music collectors and audiophiles.
 It is a fork of Clementine. The name is inspired by the band Strawbs.
 .
 Features:
  - Play and organize music
  - Supports WAV, FLAC, WavPack, Ogg Vorbis, Speex, MPC, TrueAudio,
  -   AIFF, MP4, MP3 and ASF
  - Audio CD playback
  - Native desktop notifications
  - Playlist management
  - Playlists in multiple formats
  - Advanced audio and device configuration for bit-perfect playback on Linux
  - Edit tags on audio files
  - Automatically retrieve tags from MusicBrainz
  - Album cover art from Last.fm, Musicbrainz, Discogs, Musixmatch, Deezer,
  -   Tidal, Qobuz and Spotify
  - Song lyrics from Genius, Musixmatch, ChartLyrics, lyrics.ovh,
     lololyrics.com, songlyrics.com, azlyrics.com and elyrics.net
  - Audio analyzer
  - Audio equalizer
  - Transfer music to mass-storage USB players, MTP compatible devices
  -   and iPod Nano/Classic
  - Scrobbler with support for Last.fm, Libre.fm and ListenBrainz
  - Streaming support for Subsonic-compatible servers
  - Unofficial streaming support for Tidal and Qobuz

## strawberry 1.2.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,24 +18,19 @@
 include(CheckIncludeFiles)
 include(FindPkgConfig)
 include(cmake/Version.cmake)
-include(cmake/Summary.cmake)
+include(cmake/OptionalComponent.cmake)
 include(cmake/OptionalSource.cmake)
 include(cmake/ParseArguments.cmake)
 
 if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
   set(LINUX ON)
-endif()
-if(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
-  set(FREEBSD ON)
-endif()
-if(CMAKE_SYSTEM_NAME STREQUAL "OpenBSD")
-  set(OPENBSD ON)
 endif()
 
 if(LINUX)
   include(cmake/Rpm.cmake)
   include(cmake/Deb.cmake)
 endif()
+
 if(APPLE)
   include(cmake/Dmg.cmake)
 endif()
@@ -72,7 +67,6 @@
 
 if(WIN32)
   option(ENABLE_WIN32_CONSOLE "Show the windows console even outside Debug mode" ${ENABLE_WIN32_CONSOLE_DEFAULT})
-  option(USE_QTSPARKLE "Use Qt Sparkle updater" ON)
 endif()
 
 if(MSVC)
@@ -167,17 +161,17 @@
   find_package(Boost REQUIRED)
 endif()
 find_package(ICU COMPONENTS uc i18n REQUIRED)
-if(LINUX)
-  find_package(ALSA REQUIRED)
-else()
-  find_package(ALSA)
-endif()
 if(UNIX AND NOT APPLE)
+  if(LINUX)
+    find_package(ALSA REQUIRED)
+  else()
+    find_package(ALSA)
+  endif()
   find_package(X11 COMPONENTS X11_xcb)
 endif()
 pkg_check_modules(GLIB REQUIRED IMPORTED_TARGET glib-2.0)
 pkg_check_modules(GOBJECT REQUIRED IMPORTED_TARGET gobject-2.0)
-if(UNIX AND NOT APPLE)
+if(NOT APPLE)
   pkg_check_modules(GIO REQUIRED IMPORTED_TARGET gio-2.0)
   if(GIO_FOUND AND UNIX)
     pkg_check_modules(GIO_UNIX IMPORTED_TARGET gio-unix-2.0)
@@ -191,7 +185,9 @@
 pkg_check_modules(GSTREAMER_TAG REQUIRED IMPORTED_TARGET gstreamer-tag-1.0)
 pkg_check_modules(GSTREAMER_PBUTILS REQUIRED IMPORTED_TARGET gstreamer-pbutils-1.0)
 pkg_check_modules(SQLITE REQUIRED IMPORTED_TARGET sqlite3>=3.9)
-pkg_check_modules(LIBPULSE IMPORTED_TARGET libpulse)
+if(UNIX AND NOT APPLE)
+  pkg_check_modules(LIBPULSE IMPORTED_TARGET libpulse)
+endif()
 pkg_check_modules(CHROMAPRINT IMPORTED_TARGET libchromaprint>=1.4)
 pkg_check_modules(FFTW3 IMPORTED_TARGET fftw3)
 pkg_check_modules(LIBEBUR128 IMPORTED_TARGET libebur128)
@@ -271,33 +267,36 @@
   add_definitions(-DKDSINGLEAPPLICATION_STATIC_BUILD)
 endif()
 
-# if(APPLE)
-#   find_package(SPMediaKeyTap REQUIRED)
-# endif()
+if(APPLE)
+  find_library(SPARKLE Sparkle)
+  #find_package(SPMediaKeyTap REQUIRED)
+endif()
 
 if(WIN32)
   find_package(getopt-win REQUIRED)
-  if(USE_QTSPARKLE)
-    pkg_check_modules(QTSPARKLE REQUIRED IMPORTED_TARGET qtsparkle-qt${QT_VERSION_MAJOR})
-    set(HAVE_QTSPARKLE ON)
-  endif()
-endif()
-
-optional_component(ALSA ON "ALSA integration"
-  DEPENDS "alsa" ALSA_FOUND
-)
-
-optional_component(PULSE ON "PulseAudio integration"
-  DEPENDS "libpulse" LIBPULSE_FOUND
-)
-
-optional_component(DBUS ON "D-Bus support"
-  DEPENDS "Qt D-Bus" DBUS_FOUND
-)
-
-optional_component(MPRIS2 ON "MPRIS2 D-Bus Interface"
-  DEPENDS "D-Bus support" HAVE_DBUS
-)
+endif()
+
+if(APPLE OR WIN32)
+  find_package(qtsparkle-qt${QT_VERSION_MAJOR})
+  if(TARGET "qtsparkle-qt${QT_VERSION_MAJOR}::qtsparkle")
+    set(QTSPARKLE_FOUND ON)
+  endif()
+endif()
+
+if(UNIX AND NOT APPLE)
+  optional_component(ALSA ON "ALSA integration"
+    DEPENDS "alsa" ALSA_FOUND
+  )
+  optional_component(PULSE ON "PulseAudio integration"
+    DEPENDS "libpulse" LIBPULSE_FOUND
+  )
+  optional_component(DBUS ON "D-Bus support"
+    DEPENDS "Qt D-Bus" DBUS_FOUND
+  )
+  optional_component(MPRIS2 ON "MPRIS2 D-Bus Interface"
+    DEPENDS "D-Bus support" HAVE_DBUS
+  )
+endif()
 
 optional_component(SONGFINGERPRINTING ON "Song fingerprinting and tracking"
   DEPENDS "chromaprint" CHROMAPRINT_FOUND
@@ -307,26 +306,29 @@
   DEPENDS "chromaprint" CHROMAPRINT_FOUND
 )
 
-optional_component(X11_GLOBALSHORTCUTS ON "X11 global shortcuts"
-  DEPENDS "X11" X11_FOUND
-  DEPENDS "QX11Application" HAVE_QX11APPLICATION
-)
-
-optional_component(KGLOBALACCEL_GLOBALSHORTCUTS ON "KGlobalAccel global shortcuts"
-  DEPENDS "D-Bus support" HAVE_DBUS
-)
-
-optional_component(UDISKS2 ON "Devices: UDisks2 backend"
-  DEPENDS "D-Bus support" HAVE_DBUS
-)
-
-optional_component(GIO ON "Devices: GIO device backend"
-  DEPENDS "libgio" GIO_FOUND
-)
-
-optional_component(GIO_UNIX ON "Devices: GIO device backend (Unix support)"
-  DEPENDS "libgio-unix" GIO_UNIX_FOUND
-)
+if(UNIX AND NOT APPLE)
+  optional_component(X11_GLOBALSHORTCUTS ON "X11 global shortcuts"
+    DEPENDS "X11" X11_FOUND
+    DEPENDS "QX11Application" HAVE_QX11APPLICATION
+  )
+  optional_component(KGLOBALACCEL_GLOBALSHORTCUTS ON "KGlobalAccel global shortcuts"
+    DEPENDS "D-Bus support" HAVE_DBUS
+  )
+  optional_component(UDISKS2 ON "Devices: UDisks2 backend"
+    DEPENDS "D-Bus support" HAVE_DBUS
+  )
+endif()
+
+if(NOT APPLE)
+  optional_component(GIO ON "Devices: GIO device backend"
+    DEPENDS "libgio" GIO_FOUND
+  )
+  if(UNIX)
+    optional_component(GIO_UNIX ON "Devices: GIO device backend (Unix support)"
+      DEPENDS "libgio-unix" GIO_UNIX_FOUND
+    )
+  endif()
+endif()
 
 optional_component(AUDIOCD ON "Devices: Audio CD support"
   DEPENDS "libcdio" LIBCDIO_FOUND
@@ -357,6 +359,18 @@
 optional_component(EBUR128 ON "EBU R 128 loudness normalization"
   DEPENDS "libebur128" LIBEBUR128_FOUND
 )
+
+if(APPLE)
+  optional_component(SPARKLE ON "Sparkle integration"
+    DEPENDS "Sparkle" SPARKLE
+  )
+endif()
+
+if(APPLE OR WIN32)
+  optional_component(QTSPARKLE ON "QtSparkle integration"
+    DEPENDS "QtSparkle" QTSPARKLE_FOUND
+  )
+endif()
 
 if(HAVE_SONGFINGERPRINTING OR HAVE_MUSICBRAINZ)
   set(HAVE_CHROMAPRINT ON)
@@ -392,7 +406,7 @@
 
 if(APPLE)
   set_target_properties(strawberry PROPERTIES MACOSX_BUNDLE TRUE)
-  set_target_properties(strawberry PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/dist/macos/Info.plist")
+  set_target_properties(strawberry PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_BINARY_DIR}/dist/macos/Info.plist")
 endif()
 
 if(WIN32 AND NOT ENABLE_WIN32_CONSOLE)
@@ -408,13 +422,3 @@
   src/core/commandlineoptions.cpp
   src/core/database.cpp
   src/core/memorydatabase.cpp
-  src/core/sqlquery.cpp
-  src/core/sqlrow.cpp
-  src/core/metatypes.cpp
-  src/core/deletefiles.cpp
-  src/core/filesystemmusicstorage.cpp
-  src/core/filesystemwatcherinterface.cpp
-  src/core/mergedproxymodel.cpp
-  src/core/multisortfilterproxy.cpp
-  src/core/musicstorage.cpp
-  src/core/networkaccessmanager.cpp

=== debian/changelog ===
strawberry (1.2.6-1) unstable; urgency=medium

  * New upstream release
  * Add ibkdsingleapplication-qt6-dev to d/control (#1092787)

 -- Peter Blackman <peter@pblackman.plus.com>  Mon, 20 Jan 2025 13:12:43 +0000

=== debian/control ===
--- 
+++ 
@@ -18,6 +18,7 @@
  libgstreamer-plugins-base1.0-dev,
  libgstreamer1.0-dev,
  libicu-dev,
+ libkdsingleapplication-qt6-dev,
  libmtp-dev,
  libpulse-dev,
  libsqlite3-dev,

## strawberry 1.2.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -128,7 +128,10 @@
 )
 
 if(WIN32)
-  add_definitions(-DUNICODE)
+  add_definitions(
+    -DUNICODE
+    -DNOMINMAX
+  )
 endif()
 
 if(BUILD_WERROR)
@@ -211,30 +214,23 @@
 set(QT_MIN_VERSION 6.4.0)
 set(QT_DEFAULT_MAJOR_VERSION ${QT_VERSION_MAJOR})
 set(QT_COMPONENTS Core Concurrent Gui Widgets Network Sql)
-set(QT_OPTIONAL_COMPONENTS LinguistTools Test)
+set(QT_OPTIONAL_COMPONENTS GuiPrivate LinguistTools Test)
 if(UNIX AND NOT APPLE)
   list(APPEND QT_OPTIONAL_COMPONENTS DBus)
 endif()
+set(QT_NO_PRIVATE_MODULE_WARNING ON)
 
 find_package(Qt${QT_VERSION_MAJOR} ${QT_MIN_VERSION} COMPONENTS ${QT_COMPONENTS} REQUIRED OPTIONAL_COMPONENTS ${QT_OPTIONAL_COMPONENTS})
+
+if(TARGET "Qt${QT_VERSION_MAJOR}::GuiPrivate")
+  set(QT_GUI_PRIVATE_FOUND ON)
+endif()
 
 if(Qt${QT_VERSION_MAJOR}DBus_FOUND)
   set(DBUS_FOUND ON)
 endif()
 
 if(X11_FOUND)
-
-  find_path(QPA_QPLATFORMNATIVEINTERFACE_H qpa/qplatformnativeinterface.h PATHS ${Qt${QT_VERSION_MAJOR}Gui_INCLUDE_DIRS} ${Qt${QT_VERSION_MAJOR}Gui_PRIVATE_INCLUDE_DIRS})
-  if(NOT QPA_QPLATFORMNATIVEINTERFACE_H)
-    find_path(QPA_QPLATFORMNATIVEINTERFACE_H ${Qt${QT_VERSION_MAJOR}Gui_VERSION}/QtGui/qpa/qplatformnativeinterface.h PATHS ${Qt${QT_VERSION_MAJOR}Gui_INCLUDE_DIRS} ${Qt${QT_VERSION_MAJOR}Gui_PRIVATE_INCLUDE_DIRS})
-  endif()
-  if(QPA_QPLATFORMNATIVEINTERFACE_H)
-    set(HAVE_QPA_QPLATFORMNATIVEINTERFACE_H ON)
-    message(STATUS "Have qpa/qplatformnativeinterface.h header.")
-  else()
-    message(STATUS "Missing qpa/qplatformnativeinterface.h header.")
-  endif()
-
   # Check for QX11Application (Qt 6 compiled with XCB).
   set(CMAKE_REQUIRED_FLAGS "-std=c++17")
   set(CMAKE_REQUIRED_LIBRARIES Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Gui)
@@ -249,7 +245,6 @@
   )
   unset(CMAKE_REQUIRED_FLAGS)
   unset(CMAKE_REQUIRED_LIBRARIES)
-
 endif()
 
 # SingleApplication
@@ -371,6 +366,10 @@
     DEPENDS "QtSparkle" QTSPARKLE_FOUND
   )
 endif()
+
+optional_component(QPA_QPLATFORMNATIVEINTERFACE ON "QPA Platform Native Interface"
+  DEPENDS "Qt Gui Private" QT_GUI_PRIVATE_FOUND
+)
 
 if(HAVE_SONGFINGERPRINTING OR HAVE_MUSICBRAINZ)
   set(HAVE_CHROMAPRINT ON)
@@ -422,3 +421,15 @@
   src/core/commandlineoptions.cpp
   src/core/database.cpp
   src/core/memorydatabase.cpp
+  src/core/sqlquery.cpp
+  src/core/sqlrow.cpp
+  src/core/metatypes.cpp
+  src/core/deletefiles.cpp
+  src/core/filesystemmusicstorage.cpp
+  src/core/filesystemwatcherinterface.cpp
+  src/core/mergedproxymodel.cpp
+  src/core/multisortfilterproxy.cpp
+  src/core/musicstorage.cpp
+  src/core/networkaccessmanager.cpp
+  src/core/threadsafenetworkdiskcache.cpp
+  src/core/networktimeouts.cpp

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -23,7 +23,7 @@
   ${CMAKE_SOURCE_DIR}/src
 )
 target_link_libraries(test_utils PRIVATE
-  GTest::GTest
+  GTest::gtest
   GTest::gmock
   Qt${QT_VERSION_MAJOR}::Core
   Qt${QT_VERSION_MAJOR}::Widgets
@@ -93,13 +93,14 @@
       target_link_libraries(${TEST_NAME} PRIVATE test_main)
     endif()
 
-    add_test(strawberry_tests ${TEST_NAME})
+    add_test(NAME ${TEST_NAME} COMMAND ${CMAKE_CURRENT_BINARY_DIR}/${TEST_NAME}${CMAKE_EXECUTABLE_SUFFIX})
     add_custom_command(TARGET strawberry_tests POST_BUILD COMMAND ./${TEST_NAME}${CMAKE_EXECUTABLE_SUFFIX})
     add_dependencies(build_tests ${TEST_NAME})
 endmacro(add_test_file)
 
 add_test_file(src/utilities_test.cpp false)
 add_test_file(src/concurrentrun_test.cpp false)
+add_test_file(src/mutex_protected_test.cpp false)
 add_test_file(src/mergedproxymodel_test.cpp false)
 add_test_file(src/sqlite_test.cpp false)
 add_test_file(src/tagreader_test.cpp false)

=== 3rdparty/kdsingleapplication/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
set(SOURCES KDSingleApplication/src/kdsingleapplication.cpp KDSingleApplication/src/kdsingleapplication_localsocket.cpp)
set(HEADERS KDSingleApplication/src/kdsingleapplication.h KDSingleApplication/src/kdsingleapplication_localsocket_p.h)
qt_wrap_cpp(MOC ${HEADERS})
add_library(kdsingleapplication STATIC ${SOURCES} ${MOC})
if(NOT MSVC)
  target_compile_options(kdsingleapplication PRIVATE -Wno-missing-declarations)
endif()
target_compile_definitions(kdsingleapplication PRIVATE -DKDSINGLEAPPLICATION_STATIC_BUILD)
target_include_directories(kdsingleapplication PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(kdsingleapplication PUBLIC Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Network)

=== 3rdparty/kdsingleapplication/KDSingleApplication/src/CMakeLists.txt ===
# This file is part of KDSingleApplication.
#
# SPDX-FileCopyrightText: 2020-2023 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: MIT
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#
set(KDSINGLEAPPLICATION_SRCS kdsingleapplication.cpp kdsingleapplication_localsocket.cpp)

set(KDSINGLEAPPLICATION_INSTALLABLE_INCLUDES kdsingleapplication.h kdsingleapplication_lib.h)

set(KDSINGLEAPPLICATION_NON_INSTALLABLE_INCLUDES kdsingleapplication_localsocket_p.h)

if(${PROJECT_NAME}_STATIC)
    add_library(kdsingleapplication STATIC ${KDSINGLEAPPLICATION_INSTALLABLE_INCLUDES} ${KDSINGLEAPPLICATION_SRCS})
    target_compile_definitions(kdsingleapplication PUBLIC KDSINGLEAPPLICATION_STATIC_BUILD)
else()
    add_library(kdsingleapplication SHARED ${KDSINGLEAPPLICATION_INSTALLABLE_INCLUDES} ${KDSINGLEAPPLICATION_SRCS})
    target_compile_definitions(kdsingleapplication PRIVATE KDSINGLEAPPLICATION_SHARED_BUILD)
endif()
add_library(
    KDAB::kdsingleapplication ALIAS kdsingleapplication
)
set_target_properties(
    kdsingleapplication
    PROPERTIES VERSION ${${PROJECT_NAME}_VERSION}
               SOVERSION ${${PROJECT_NAME}_SOVERSION}
               OUTPUT_NAME "kdsingleapplication${${PROJECT_NAME}_LIBRARY_QTID}"
)

target_include_directories(
    kdsingleapplication
    PUBLIC $<INSTALL_INTERFACE:${KDSINGLEAPPLICATION_INCLUDEDIR}> $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}
)

if(WIN32)
    target_link_libraries(kdsingleapplication PRIVATE kernel32)
endif()
target_link_libraries(
    kdsingleapplication
    PUBLIC Qt::Core
    PRIVATE Qt::Network
)

install(
    FILES ${KDSINGLEAPPLICATION_INSTALLABLE_INCLUDES}
    DESTINATION ${KDSINGLEAPPLICATION_INCLUDEDIR}
)

install(
    TARGETS kdsingleapplication
    EXPORT kdsingleapplicationTargets
    RUNTIME DESTINATION ${INSTALL_RUNTIME_DIR}
    LIBRARY DESTINATION ${INSTALL_LIBRARY_DIR}
    ARCHIVE DESTINATION ${INSTALL_ARCHIVE_DIR}
)

include(ECMGenerateHeaders)
ecm_generate_headers(
    kdsingleapplication_HEADERS
    HEADER_NAMES
    KDSingleApplication
    OUTPUT_DIR
    ${CMAKE_CURRENT_BINARY_DIR}/KDSingleApplication
)

if(${PROJECT_NAME}_IS_ROOT_PROJECT)
    install(
        EXPORT kdsingleapplicationTargets
        FILE KDSingleApplicationTargets.cmake
        NAMESPACE KDAB::
        DESTINATION ${INSTALL_LIBRARY_DIR}/cmake/KDSingleApplication${KDSingleApplication_LIBRARY_QTID}
    )
    configure_file(
        KDSingleApplicationConfig.cmake.in KDSingleApplication${KDSingleApplication_LIBRARY_QTID}Config.cmake @ONLY
    )
    install(
        FILES "${CMAKE_CURRENT_BINARY_DIR}/KDSingleApplication${KDSingleApplication_LIBRARY_QTID}Config.cmake"
              "${CMAKE_CURRENT_BINARY_DIR}/KDSingleApplication${KDSingleApplication_LIBRARY_QTID}ConfigVersion.cmake"
        DESTINATION "${INSTALL_LIBRARY_DIR}/cmake/KDSingleApplication${KDSingleApplication_LIBRARY_QTID}"
    )

    install(FILES ${kdsingleapplication_HEADERS} DESTINATION ${KDSINGLEAPPLICATION_INCLUDEDIR})

    if(MSVC AND NOT ${PROJECT_NAME}_STATIC)
        install(
            FILES "$<TARGET_PDB_FILE_DIR:kdsingleapplication>/$<TARGET_PDB_FILE_NAME:kdsingleapplication>"
            DESTINATION ${INSTALL_LIBRARY_DIR}
            CONFIGURATIONS Debug RelWithDebInfo
        )
    endif()
endif()

# Generate library version files
include(ECMSetupVersion)
ecm_setup_version(
    ${${PROJECT_NAME}_VERSION}
    VARIABLE_PREFIX
    KDSINGLEAPPLICATION
    VERSION_HEADER
    "${CMAKE_CURRENT_BINARY_DIR}/kdsingleapplication_version.h"
    PACKAGE_VERSION_FILE
    "${CMAKE_CURRENT_BINARY_DIR}/KDSingleApplication${KDSingleApplication_LIBRARY_QTID}ConfigVersion.cmake"
    SOVERSION
    ${${PROJECT_NAME}_SOVERSION}
    COMPATIBILITY
    AnyNewerVersion
)
install(
    FILES "${CMAKE_CURRENT_BINARY_DIR}/kdsingleapplication_version.h"
    DESTINATION ${KDSINGLEAPPLICATION_INCLUDEDIR}
)
install(
    EXPORT kdsingleapplicationTargets
    FILE KDSingleApplication${KDSingleApplication_LIBRARY_QTID}Targets.cmake
    NAMESPACE KDAB::
    DESTINATION ${INSTALL_LIBRARY_DIR}/cmake/KDSingleApplication${KDSingleApplication_LIBRARY_QTID}
)

=== 3rdparty/kdsingleapplication/KDSingleApplication/tests/auto/CMakeLists.txt ===
# This file is part of KDSingleApplication.
#
# SPDX-FileCopyrightText: 2020-2023 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: MIT
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#
add_subdirectory(simpletest)
add_subdirectory(stresstest)

=== 3rdparty/kdsingleapplication/KDSingleApplication/tests/auto/simpletest/CMakeLists.txt ===
# This file is part of KDSingleApplication.
#
# SPDX-FileCopyrightText: 2020-2023 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: MIT
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#
add_subdirectory(simpletest)
add_subdirectory(test)

=== 3rdparty/kdsingleapplication/KDSingleApplication/tests/auto/simpletest/test/CMakeLists.txt ===
# This file is part of KDSingleApplication.
#
# SPDX-FileCopyrightText: 2020-2023 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: MIT
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#
include_directories(${CMAKE_SOURCE_DIR}/src)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(
    tst_simpletest
    ../tst_simpletest.cpp
)
target_link_libraries(
    tst_simpletest Qt::Test
)
add_test(NAME tst_simpletest COMMAND tst_simpletest)

=== 3rdparty/kdsingleapplication/KDSingleApplication/tests/auto/stresstest/stresstest/CMakeLists.txt ===
# This file is part of KDSingleApplication.
#
# SPDX-FileCopyrightText: 2020-2023 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: MIT
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#
set(stresstest_SRCS main.cpp)
add_executable(
    stresstest
    ${stresstest_SRCS}
)
target_link_libraries(
    stresstest Qt::Widgets kdsingleapplication
)

=== debian/changelog ===
strawberry (1.2.7-2) unstable; urgency=medium

  * Build with kdsingleapplication (Closes: #1092787)

 -- Peter Blackman <peter@pblackman.plus.com>  Mon, 03 Feb 2025 18:41:22 +0000

strawberry (1.2.7-1) unstable; urgency=medium

  * New upstream release
  * Extra build dependencies, libxkbcommon-dev, qt6-base-private-dev

 -- Peter Blackman <peter@pblackman.plus.com>  Sat, 01 Feb 2025 14:33:45 +0000

=== debian/control ===
--- 
+++ 
@@ -18,6 +18,7 @@
  libgstreamer-plugins-base1.0-dev,
  libgstreamer1.0-dev,
  libicu-dev,
+ libxkbcommon-dev,
  libkdsingleapplication-qt6-dev,
  libmtp-dev,
  libpulse-dev,
@@ -25,6 +26,7 @@
  libtag-c-dev,
  libvlc-dev,
  qt6-base-dev,
+ qt6-base-private-dev,
  qt6-base-dev-tools,
  qt6-l10n-tools,
  qt6-tools-dev,

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS   = hardening=+all

%:
	dh $@

# Rename script
execute_after_dh_auto_install:
	cp -v dist/scripts/import-from-clementine.sh \
	      debian/strawberry/usr/bin/strawberry-import-from-clementine

## strawberry 1.2.9

=== debian/changelog ===
strawberry (1.2.9-2) unstable; urgency=medium

  * Drop patch for kdsingleapplication version 1.0.0
  * Include debian/files in debian/clean

 -- Peter Blackman <peter@pblackman.plus.com>  Fri, 11 Apr 2025 14:09:53 +0100

strawberry (1.2.9-1) unstable; urgency=medium

  * New upstream version 1.2.9

 -- Peter Blackman <peter@pblackman.plus.com>  Thu, 10 Apr 2025 12:41:13 +0100

strawberry (1.2.8-1) unstable; urgency=medium

  * New upstream version 1.2.8
  * Add import-orig filter to gbp.conf
  * New upstream release
  *  (https://forum.strawberrymusicplayer.org/topic/5764/version-1-2-8-released)
  * Refresh patches
  * Update build dependencies
  * Standards 4.7.2 (No changes)
  * Update d/copyright
  * Drop unneeded lintian override

 -- Peter Blackman <peter@pblackman.plus.com>  Sun, 06 Apr 2025 13:20:08 +0100

=== debian/control ===
--- 
+++ 
@@ -6,32 +6,32 @@
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
+ libglib2.0-dev,
+ libboost-dev,
+ libsqlite3-dev,
  libasound2-dev,
- libboost-dev,
- libcdio-dev,
- libchromaprint-dev,
- libebur128-dev,
- libfftw3-dev,
- libglib2.0-dev,
- libgnutls28-dev,
- libgpod-dev,
- libgstreamer-plugins-base1.0-dev,
- libgstreamer1.0-dev,
+ libpulse-dev,
+ libtag1-dev,
  libicu-dev,
  libxkbcommon-dev,
- libkdsingleapplication-qt6-dev,
- libmtp-dev,
- libpulse-dev,
- libsqlite3-dev,
- libtag-c-dev,
- libvlc-dev,
  qt6-base-dev,
  qt6-base-private-dev,
  qt6-base-dev-tools,
+ qt6-tools-dev,
+ qt6-tools-dev-tools,
  qt6-l10n-tools,
- qt6-tools-dev,
- qt6-tools-dev-tools
-Standards-Version: 4.7.0
+ libkdsingleapplication-qt6-dev,
+ libgstreamer1.0-dev,
+ libgstreamer-plugins-base1.0-dev,
+ libcdio-dev,
+ libgpod-dev,
+ libmtp-dev,
+ libchromaprint-dev,
+ libfftw3-dev,
+ libebur128-dev,
+ libsparsehash-dev,
+ rapidjson-dev
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/strawberry
 Vcs-Git: https://salsa.debian.org/debian/strawberry.git

## strawberry 1.2.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -81,7 +81,7 @@
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 if(MSVC)
-  list(APPEND COMPILE_OPTIONS /MP)
+  list(APPEND COMPILE_OPTIONS -MP -W4 -wd4702)
 else()
   list(APPEND COMPILE_OPTIONS
     $<$<COMPILE_LANGUAGE:C>:-std=c11>
@@ -210,6 +210,10 @@
 
 find_package(GTest)
 
+pkg_check_modules(LIBSPARSEHASH IMPORTED_TARGET libsparsehash)
+
+find_package(RapidJSON)
+
 set(QT_VERSION_MAJOR 6)
 set(QT_MIN_VERSION 6.4.0)
 set(QT_DEFAULT_MAJOR_VERSION ${QT_VERSION_MAJOR})
@@ -247,20 +251,7 @@
   unset(CMAKE_REQUIRED_LIBRARIES)
 endif()
 
-# SingleApplication
-set(KDSINGLEAPPLICATION_NAME "KDSingleApplication-qt${QT_VERSION_MAJOR}")
-find_package(${KDSINGLEAPPLICATION_NAME} 1.1.0)
-if(TARGET KDAB::kdsingleapplication)
-  set(KDSINGLEAPPLICATION_VERSION "${KDSingleApplication-qt6_VERSION}")
-  message(STATUS "Using system KDSingleApplication (Version ${KDSINGLEAPPLICATION_VERSION})")
-  set(SINGLEAPPLICATION_LIBRARIES KDAB::kdsingleapplication)
-else()
-  message(STATUS "Using 3rdparty KDSingleApplication")
-  add_subdirectory(3rdparty/kdsingleapplication)
-  set(SINGLEAPPLICATION_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/kdsingleapplication/KDSingleApplication/src)
-  set(SINGLEAPPLICATION_LIBRARIES kdsingleapplication)
-  add_definitions(-DKDSINGLEAPPLICATION_STATIC_BUILD)
-endif()
+find_package(KDSingleApplication-qt${QT_VERSION_MAJOR} 1.1.0 REQUIRED)
 
 if(APPLE)
   find_library(SPARKLE Sparkle)
@@ -369,6 +360,14 @@
 
 optional_component(QPA_QPLATFORMNATIVEINTERFACE ON "QPA Platform Native Interface"
   DEPENDS "Qt Gui Private" QT_GUI_PRIVATE_FOUND
+)
+
+optional_component(STREAMTAGREADER ON "Stream tagreader"
+  DEPENDS "sparsehash" LIBSPARSEHASH_FOUND
+)
+
+optional_component(DISCORD_RPC ON "Discord Rich Presence"
+  DEPENDS "RapidJSON" RapidJSON_FOUND
 )
 
 if(HAVE_SONGFINGERPRINTING OR HAVE_MUSICBRAINZ)
@@ -433,3 +432,17 @@
   src/core/networkaccessmanager.cpp
   src/core/threadsafenetworkdiskcache.cpp
   src/core/networktimeouts.cpp
+  src/core/networkproxyfactory.cpp
+  src/core/qtfslistener.cpp
+  src/core/settings.cpp
+  src/core/settingsprovider.cpp
+  src/core/signalchecker.cpp
+  src/core/song.cpp
+  src/core/songloader.cpp
+  src/core/stylehelper.cpp
+  src/core/stylesheetloader.cpp
+  src/core/taskmanager.cpp
+  src/core/thread.cpp
+  src/core/urlhandler.cpp
+  src/core/urlhandlers.cpp
+  src/core/iconloader.cpp

=== 3rdparty/discord-rpc/CMakeLists.txt ===
set(DISCORD_RPC_SOURCES
  discord_rpc.h
  discord_register.h
  discord_rpc.cpp
  discord_rpc_connection.h
  discord_rpc_connection.cpp
  discord_serialization.h
  discord_serialization.cpp
  discord_connection.h
  discord_backoff.h
  discord_msg_queue.h
)

if(UNIX)
  list(APPEND DISCORD_RPC_SOURCES discord_connection_unix.cpp)
  if(APPLE)
    list(APPEND DISCORD_RPC_SOURCES discord_register_osx.m)
    add_definitions(-DDISCORD_OSX)
  else()
    list(APPEND DISCORD_RPC_SOURCES discord_register_linux.cpp)
    add_definitions(-DDISCORD_LINUX)
  endif()
endif()

if(WIN32)
  list(APPEND DISCORD_RPC_SOURCES discord_connection_win.cpp discord_register_win.cpp)
  add_definitions(-DDISCORD_WINDOWS)
endif()

add_library(discord-rpc STATIC ${DISCORD_RPC_SOURCES})

if(APPLE)
  target_link_libraries(discord-rpc PRIVATE "-framework AppKit")
endif()

if(WIN32)
  target_link_libraries(discord-rpc PRIVATE psapi advapi32)
endif()

target_include_directories(discord-rpc SYSTEM PRIVATE ${RapidJSON_INCLUDE_DIRS})
target_include_directories(discord-rpc PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})

=== debian/changelog ===
strawberry (1.2.10-2) unstable; urgency=medium

  [ Boyuan Yang ]
  * debian/control: Avoid transitional pkg libtag1-dev

  [ PeterB ]
  * Fix 'translations-not-found' AppStream warning

 -- Peter Blackman <peter@pblackman.plus.com>  Sat, 03 May 2025 13:11:42 +0100

strawberry (1.2.10-1) unstable; urgency=medium

  * New upstream version 1.2.10
  * Refresh patch
  * Trim debian/clean
  * Remove reference to Genius in debian/control
  * Update copyright dates

 -- Peter Blackman <peter@pblackman.plus.com>  Sat, 19 Apr 2025 17:28:14 +0100

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  libsqlite3-dev,
  libasound2-dev,
  libpulse-dev,
- libtag1-dev,
+ libtag-dev,
  libicu-dev,
  libxkbcommon-dev,
  qt6-base-dev,
@@ -70,7 +70,7 @@
   - Automatically retrieve tags from MusicBrainz
   - Album cover art from Last.fm, Musicbrainz, Discogs, Musixmatch, Deezer,
   -   Tidal, Qobuz and Spotify
-  - Song lyrics from Genius, Musixmatch, ChartLyrics, lyrics.ovh,
+  - Song lyrics from Musixmatch, ChartLyrics, lyrics.ovh,
      lololyrics.com, songlyrics.com, azlyrics.com and elyrics.net
   - Audio analyzer
   - Audio equalizer
